;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;               Bambin                                              ;;;;;
;;;;;                                                                   ;;;;;
;;;;;   Fichier de Base.                                                ;;;;;
;;;;;       Mose Valvassori  - 20.06.99                                ;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;	$Id$	


(display "Base. ")
(require 'macro-by-example)			  ; Dfinit (define-syntax)
						  ; Il faut la SLIB


;-------- Divers --------------------------------------------
;; Ca peut tre pratique :-(

(define (repeat n funx)
(if (zero? n) (funx n)
    (begin
      (funx n)
      (repeat (- n 1) funx)))
)
(define (retirer-de-la-liste objet liste)
  (cond ((null? liste)
	 (error "fin de la liste" liste))
	((equal? objet (car liste))
	 (cdr liste))
	(else (cons (car liste) (retirer-de-la-liste objet (cdr liste))))
  ))


;-------- Le langage ----------------------------------------

(define (ecrire x)
  (display x))

(define-syntax repeter
  (syntax-rules ()
    ((repeter n funct)
     (if (= 1 n)
	 funct
	 (begin
	   funct
	   (repeter (- n 1) funct)))
     )
    ((repeter n funct ...)
     (if (= 1 n)
	 (begin
	   funct
	   ...
	   )
	 (begin
	   funct
	   ...
	   (repeter (- n 1) funct ...)))
     )))

(define-syntax apprendre
  (syntax-rules ()
    ((apprendre (quoi p) comment ...)
     (define (quoi p) comment ...))
    ((apprendre quoi comment ...)
     (define (quoi) comment ...))
    ))

(define-syntax si
  (syntax-rules ()
    ((si c e1 e2)
     (if (or (eq? c #f) (eq? c 'non))
	 e2
	 e1)
     )))

(define non 'non)
(define oui 'oui)
(define (rien? x) (if (null? x) oui non))
(define rien 'rien)


;------- La tortue ------------------------------------------

(define (creer-tortue) 
  (let ((tortue-x 0)
	(tortue-y 0)
	(tortue-dir 'droite)
	(tortue-sac '()))
    (define (avancer?)
      (case tortue-dir
	((droite) (> limite-x tortue-x))
	((gauche) (< 0 tortue-x))
	((haut)    (< 0 tortue-y))
	((bas)   (> limite-y tortue-y))
	))
    (define (reculer?)
      (case tortue-dir
	((gauche) (> limite-x tortue-x))
	((droite) (< 0 tortue-x))
	((bas)    (< 0 tortue-y))
	((haut)   (> limite-y tortue-y))
	))

    (lambda (mesg . param)
      (case mesg
	((etat)					  ; renvoie l'tat de la tortue
	 (list tortue-x tortue-y tortue-dir))
	((avancer)				  ; avance la tortue
	 (if (avancer?)
	     (case tortue-dir
	       ((droite) (set! tortue-x (+ tortue-x 1)))
	       ((gauche) (set! tortue-x (- tortue-x 1)))
	       ((bas)    (set! tortue-y (+ tortue-y 1)))
	       ((haut)   (set! tortue-y (- tortue-y 1))))
	     "je peux pas avancer"
	     ))
	((reculer)				  ; recule la tortue
	 (if (reculer?)
	     (case tortue-dir
	       ((droite) (set! tortue-x (- tortue-x 1)))
	       ((gauche) (set! tortue-x (+ tortue-x 1)))
	       ((bas)    (set! tortue-y (- tortue-y 1)))
	       ((haut)   (set! tortue-y (+ tortue-y 1))))
	     "je peux pas reculer"
	     ))
	((peut-avancer?)			  ; vrai si la tortue peut avancer
	 (avancer?))
	((tourner-droite)			  ; Rotation  droite
	 (case tortue-dir
	   ((droite) (set! tortue-dir 'bas))
	   ((bas)    (set! tortue-dir 'gauche))
	   ((gauche) (set! tortue-dir 'haut))
	   ((haut)   (set! tortue-dir 'droite))
	   ))
	((tourner-gauche)			  ; Rotation  gauche
	 (case tortue-dir
	   ((droite) (set! tortue-dir 'haut))
	   ((bas)    (set! tortue-dir 'droite))
	   ((gauche) (set! tortue-dir 'bas))
	   ((haut)   (set! tortue-dir 'gauche))
	   ))
	((contenu-sac)				  ; Contenu du sac
	 tortue-sac)
	((mettre-dans-le-sac)			  ; 
	 (let ((objet (car param)))
	   (cond 
	    ((memq objet 
		   (regarder-dans-le-monde tortue-x tortue-y))
	     (set! tortue-sac (cons objet tortue-sac))
	     (retirer-du-monde tortue-x tortue-y objet))
	    (else "Je ne vois pas ce que vous me demandez")
	    )))
	((sortir-du-sac)
	 (let ((objet (car param)))
	   (cond 
	    ((memq objet tortue-sac)
	     (set! tortue-sac (retirer-de-la-liste objet tortue-sac))
	     (poser-dans-le-monde tortue-x tortue-y objet))
	    (else "Je ne vois pas ce que vous me demandez")
	    )))
	   
	))
    ))

(define tortue (creer-tortue))

(apprendre etat (tortue 'etat))

(apprendre position-tortue-x (car (etat)))
(apprendre position-tortue-y (cadr (etat)))
(apprendre direction-tortue (caddr (etat)))

(apprendre avancer (tortue 'avancer))

(apprendre tourner-gauche (tortue 'tourner-gauche))

(apprendre tourner-droite (tortue 'tourner-droite))

(apprendre peut-avancer?
  (si (tortue 'peut-avancer?)
    'oui
    'non))

(apprendre regarder (si 
	   (null? (regarder-dans-le-monde (position-tortue-x) (position-tortue-y)))
	   rien
	   (regarder-dans-le-monde (position-tortue-x) (position-tortue-y))
	   ))

(define prendre (lambda chose 
		  (si (rien? chose)
		      "Prendre quoi?"
		      (tortue 'mettre-dans-le-sac (car chose))
		      )))

(define poser (lambda chose 
		  (si (rien? chose)
		      "Poser quoi?"
		      (tortue 'sortir-du-sac (car chose))
		      )))

(apprendre contenu-du-sac (tortue 'contenu-sac))


;--------- Le Monde -----------------------------------------

(define (creer-monde)
  (let ((vec (make-vector limite-x)))
    (define (tmp n)
      (if (= n -1)
	  vec
	  (begin
	    (vector-set! vec n (make-vector limite-y '()))
	    (tmp (- n 1))
	    )))
    (tmp (- limite-x 1))
    ))
(define monde (creer-monde))

(define (ligne-du-monde y)			  ; Renvoie un vecteur qui
  (vector-ref monde y))				  ; contient la y ieme ligne

(define (regarder-dans-le-monde x y)
  (vector-ref (ligne-du-monde y) x)
  )

(define (poser-dans-le-monde x y obj)
  (vector-set! (ligne-du-monde y) x 
	       (cons obj (regarder-dans-le-monde x y))
	       ))
(define (retirer-du-monde x y obj)
  (vector-set! (ligne-du-monde y) x 
	       (retirer-de-la-liste obj (regarder-dans-le-monde x y))
	       ))
(define-syntax creer-objet
  (syntax-rules ()
    ((creer-objet objet)
     (define objet 'objet))
    ))


;----- Fin du listing ---------------------------------------

